unit hiRemoteAccessManager;

interface
     
uses Messages,Windows,Kol,Share,Debug,Win;

type
  TWinEx = class;
  PWinEx = TWinEx;
  TWinEx = class(THIWin)
end;

type
  THIRemoteAccessManager = class(TDebug)
   private
     fControlManager: IControlManager;
     WE: PWinEx;
     OldMessage: TOnMessage;     
     sControl: PControl;
     Icon: PIcon;

     fOnMouseEnter: THI_Event;
     fOnMouseLeave: THI_Event;
     fOnPaint: THI_Event;
     fOnSplitUp: THI_Event;

     _IsConnectMouseEnter: boolean;
     _IsConnectMouseLeave: boolean;
     _IsConnectOnPaint: boolean;
     _IsConnectOnSplitUp: boolean;

     procedure SetControlManager(Value: IControlManager);
     function OnMessage(var Msg: TMsg; var Rslt: Integer): Boolean;
     procedure SetMouseEnter(Ev: THI_Event);
     procedure SetMouseLeave(Ev: THI_Event);
     procedure SetOnPaint(Ev: THI_Event);
     procedure SetOnSplitUp(Ev:THI_Event);     
   public
	 _event_onKeyUp: THI_Event;
	 _event_onKeyDown: THI_Event;
	 _event_onChar: THI_Event;	 
	 _event_onShow: THI_Event;
	 _event_onHide: THI_Event;
	 _event_onResize: THI_Event;	 
	 _event_onMouseDown: THI_Event;
	 _event_onMouseMove: THI_Event;
	 _event_onMouseWheel: THI_Event;
	 _event_onMouseUp: THI_Event;	 
	 _event_onMove: THI_Event;
	 _event_onDblClick: THI_Event;
	 _event_onSetFocus: THI_Event;
	 _event_onKillFocus: THI_Event;

	 constructor Create;
	 destructor Destroy; override;
     procedure _work_doLeft(var _Data:TData; Index:word);
     procedure _work_doTop(var _Data:TData; Index:word);
     procedure _work_doWidth(var _Data:TData; Index:word);
     procedure _work_doHeight(var _Data:TData; Index:word);
     procedure _work_doColor(var _Data:TData; Index:word);
     procedure _work_doVisible(var _Data:TData; Index:word);
     procedure _work_doEnabled(var _Data:TData; Index:word);
     procedure _work_doHint(var _Data:TData; Index:word);
     procedure _work_doSetFocus(var _Data:TData; Index:word);
     procedure _work_doSendToBack(var _Data:TData; Index:word);
     procedure _work_doBringToFront(var _Data:TData; Index:word);
     procedure _work_doCenterPos(var _Data:TData; Index:word);
     procedure _work_doAlphaBlendValue(var _Data:TData; Index:word);
     procedure _work_doCaption(var _Data:TData; Index:word); 
     procedure _var_Handle(var _Data:TData; Index:word);
     procedure _var_PHandle(var _Data:TData; Index:word);     
     procedure _var_Width(var _Data:TData; Index:word);
     procedure _var_Height(var _Data:TData; Index:word);
     procedure _var_Left(var _Data:TData; Index:word);
     procedure _var_Top(var _Data:TData; Index:word);
     procedure _var_MouseX(var _Data:TData; Index:word);
     procedure _var_MouseY(var _Data:TData; Index:word);
     procedure _var_Color(var _Data:TData; Index:word);
     procedure _var_Caption(var _Data:TData; Index:word);     
     procedure _var_Icon(var _Data:TData; Index:word);
     procedure _var_SizeHeader(var _Data:TData; Index:word);
     procedure _var_SizeBorder(var _Data:TData; Index:word);      

     property _prop_ControlManager: IControlManager read fControlManager write SetControlManager;
     property _event_onSplitUp: THI_Event write SetOnSplitUp;
     property _event_onMouseEnter: THI_Event read fOnMouseEnter write SetMouseEnter;
     property _event_onMouseLeave: THI_Event read fOnMouseLeave write SetMouseLeave;
     property _event_onPaint: THI_Event read fOnPaint write SetOnPaint;
  end;

implementation

function THIRemoteAccessManager.OnMessage;
begin
  Result := false;
  if Msg.message = US_KEYUP then
    _hi_onEvent(_event_onKeyUp, Msg.lparam)
  else if Msg.message = US_KEYDOWN then
    _hi_onEvent(_event_onKeyDown, Msg.lparam)
  else if Msg.message = US_CHAR then
    _hi_onEvent(_event_onChar, string(Msg.lparam))
  else if Msg.message = US_SHOW then
    _hi_onEvent(_event_onShow)
  else if Msg.message = US_HIDE then
    _hi_onEvent(_event_onHide)
  else if Msg.message = US_RESIZE then
    _hi_onEvent(_event_onResize)
  else if Msg.message = US_MOUSEDOWN then
    _hi_onEvent(_event_onMouseDown, Msg.lparam)
  else if Msg.message = US_MOUSEMOVE then
    _hi_onEvent(_event_onMouseMove, Msg.lparam)
  else if Msg.message = US_MOUSEUP then
    _hi_onEvent(_event_onMouseUp, Msg.lparam)
  else if Msg.message = US_MOUSEWHEEL then
	_hi_onEvent(_event_onMouseWheel, Msg.lparam)
  else if Msg.message = US_MOVE then
    _hi_onEvent(_event_onMove)
  else if Msg.message = US_PAINT then
    _hi_onEvent(fOnPaint, Msg.lparam)  
  else if Msg.message = US_MOUSEDBLCLK then
    _hi_onEvent(_event_onDblClick, Msg.lparam)
  else if  Msg.message = US_MOUSEENTER then
    _hi_onEvent(fOnMouseEnter)  
  else if  Msg.message = US_MOUSELEAVE then
    _hi_onEvent(fOnMouseLeave)
  else if  Msg.message = US_SETFOCUS then
    _hi_onEvent(_event_onSetFocus)
  else if  Msg.message = US_KILLFOCUS then
    _hi_onEvent(_event_onKillFocus)
  else if  Msg.message = US_SPLITUP then
    _hi_onEvent(fOnSplitUp);
	  
  Result := Result or _hi_OnMessage(OldMessage, Msg, Rslt);  
end;  

constructor THIRemoteAccessManager.Create;
begin
  inherited;
  _IsConnectMouseEnter := false;
  _IsConnectMouseLeave := false;
  _IsConnectOnPaint    := false;
  _IsConnectOnSplitUp  := false;
end;

destructor THIRemoteAccessManager.Destroy;
begin
  If Assigned(Icon) then Icon.free;
  inherited;
end;

procedure THIRemoteAccessManager.SetMouseEnter;
begin
  fOnMouseEnter := ev;
  _IsConnectMouseEnter :=true;  
end;

procedure THIRemoteAccessManager.SetMouseLeave;
begin
  fOnMouseLeave := ev;
  _IsConnectMouseLeave := true;  
end;

procedure THIRemoteAccessManager.SetOnPaint;
begin
  fOnPaint := Ev;
  _IsConnectOnPaint := true;
end;

procedure THIRemoteAccessManager.SetOnSplitUp;
begin
   fOnSplitUp := Ev;
   _IsConnectOnSplitUp := true;
end;

procedure THIRemoteAccessManager.SetControlManager;
begin
  fControlManager := Value;
  if not Assigned(fControlManager) then exit;
  sControl := fControlManager.ctrlpoint;

  WE := PWinEx(fControlManager.getclass);

  OldMessage:= sControl.OnMessage;
  sControl.OnMessage := OnMessage;
  
  if (not WE._IsConnectMouseEnter) and _IsConnectMouseEnter then
  begin
    sControl.onMouseEnter := WE._onMouseEnter;
    WE._IsConnectMouseEnter := true;
  end;
  if (not WE._IsConnectMouseLeave) and _IsConnectMouseLeave then
  begin
    sControl.onMouseLeave := WE._onMouseLeave;
    WE._IsConnectMouseLeave := true;
  end;
  if (not WE._IsConnectOnPaint) and _IsConnectOnPaint then
  begin
    WE.OldPaint := sControl.OnPaint;
    sControl.OnPaint := WE._OnPaint;
    WE._IsConnectOnPaint := true;
  end;
  if (not WE._IsConnectOnSplitUp) and _IsConnectOnSplitUp and (WE.Split <> nil) then
  begin
    WE.Split.onMouseUp := WE._onSplitUp;
    WE._IsConnectOnSplitUp := true;
  end;     
end;

procedure THIRemoteAccessManager._work_doLeft;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Left := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doTop;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Top := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doWidth;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Width := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doHeight;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Height := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doColor;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Color := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doVisible;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doVisible(_Data, Index);  
end;

procedure THIRemoteAccessManager._work_doEnabled;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Enabled := ReadBool(_Data);
end;

procedure THIRemoteAccessManager._work_doHint;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doHint(_Data, Index);
end;

procedure THIRemoteAccessManager._work_doSetFocus;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Focused := true;
end;

procedure THIRemoteAccessManager._work_doSendToBack;
begin
  if not Assigned(fControlManager) then exit;
  sControl.SendToBack;
end;

procedure THIRemoteAccessManager._work_doBringToFront;
begin
  if not Assigned(fControlManager) then exit;
  sControl.BringToFront;  
end;

procedure THIRemoteAccessManager._work_doCenterPos;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doCenterPos(_Data, Index);  
end;

procedure THIRemoteAccessManager._work_doAlphaBlendValue;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
    sControl.AlphaBlend := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doCaption;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Caption := ToString(_Data); 
end;

procedure THIRemoteAccessManager._var_Handle;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Handle);  
end;

procedure THIRemoteAccessManager._var_PHandle;     
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, integer(sControl));
end;

procedure THIRemoteAccessManager._var_Width;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Width);
end;

procedure THIRemoteAccessManager._var_Height;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Height);
end;

procedure THIRemoteAccessManager._var_Left;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Left);
end;

procedure THIRemoteAccessManager._var_Top;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Top);
end;

procedure THIRemoteAccessManager._var_MouseX;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, WE.Ms.X);
end;

procedure THIRemoteAccessManager._var_MouseY;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, WE.Ms.X);
end;

procedure THIRemoteAccessManager._var_Color;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, Color2RGB(sControl.Color));
end;

procedure THIRemoteAccessManager._var_Caption;
begin
  if not Assigned(fControlManager) then exit;
  dtString(_Data, sControl.Caption);
end; 

procedure THIRemoteAccessManager._var_Icon;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    if Assigned(Icon) then
      Icon.Clear
	else
      Icon := NewIcon;
    Icon.Handle := sControl.Icon;
    dtIcon(_Data, Icon);
  end
  else
    dtNull(_Data);    
end;

procedure THIRemoteAccessManager._var_SizeHeader;
var
  Pt: TPoint;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    Pt.x := 0; Pt.y := 0;
    ClientToScreen(sControl.Handle, Pt);
    dtInteger(_Data, Pt.Y - sControl.Top);
  end
  else
    dtNull(_Data);    
end;

procedure THIRemoteAccessManager._var_SizeBorder;  
var
  Pt: TPoint;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    Pt.x := 0; Pt.y := 0;
    ClientToScreen(sControl.Handle, Pt);
    dtInteger(_Data, Pt.X - sControl.Left);
  end
  else
    dtNull(_Data); 
end;
end.